const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const vendors = sequelize.define(
    'vendors',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      vendor_name: {
        type: DataTypes.TEXT,
      },

      contact_email: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  vendors.associate = (db) => {
    db.vendors.belongsToMany(db.purchase_orders, {
      as: 'purchase_orders',
      foreignKey: {
        name: 'vendors_purchase_ordersId',
      },
      constraints: false,
      through: 'vendorsPurchase_ordersPurchase_orders',
    });

    db.vendors.belongsToMany(db.purchase_orders, {
      as: 'purchase_orders_filter',
      foreignKey: {
        name: 'vendors_purchase_ordersId',
      },
      constraints: false,
      through: 'vendorsPurchase_ordersPurchase_orders',
    });

    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.vendors.hasMany(db.purchase_orders, {
      as: 'purchase_orders_vendor',
      foreignKey: {
        name: 'vendorId',
      },
      constraints: false,
    });

    //end loop

    db.vendors.belongsTo(db.companies, {
      as: 'companies',
      foreignKey: {
        name: 'companiesId',
      },
      constraints: false,
    });

    db.vendors.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.vendors.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return vendors;
};
